public class Logic
{
    private Array a1, a2,a3, a4, a5, a6;
    private Boolean b1, b2, b3, b4, b5, b6, invalidInput, run;
    private UserInput u;
    private int answer;

    public Logic (int ArraySize)
    {
        a1 = new Array(ArraySize, 1);
        a2 = new Array(ArraySize, 2);
        a3 = new Array(ArraySize, 3);
        a4 = new Array(ArraySize, 4);
        a5 = new Array(ArraySize, 5);
        a6 = new Array(ArraySize, 6);
        b1 = false;
        b2 = false;
        b3 = false;
        b4 = false;
        b5 = false;
        b6 = false;
        u = new UserInput();
        answer = 0;
        invalidInput = false;
        run = true;
    }//end constructor

    public void intro()
    {
        Console.WriteLine("This is a game where I will try to guess the number");
        Console.WriteLine("you're thinking of.");
        Thread.Sleep(2000);
        Console.WriteLine("Think of a whole number from 1 to 63.");
        Thread.Sleep(7000);
        Console.WriteLine("I will show you 6 sets of number and you will answer");
        Console.WriteLine("yes or no if your number is in that set.");
        Console.WriteLine(" ");
        Thread.Sleep(2000);
    }// end intro()

    public void showNumberSet(int type)
    {
        string inputString;
        switch (type)
        {
            case 1:
                a1.buildArray();
                a1.display();
                Console.WriteLine("Is your number here?");
                Console.WriteLine("Y/N: ");
                inputString = u.getUserInput();
                inputString = inputString.ToLower();
                if (inputString.Equals("y"))
                    b1 = true;
                else if (inputString.Equals("n"))
                    b1 = false;
                else
                    invalidInput = true;
                break;
            case 2:
                if (!invalidInput)
                {
                    a2.buildArray();
                    a2.display();
                    Console.WriteLine("Is your number here?");
                    Console.WriteLine("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.ToLower();
                    if (inputString.Equals("y"))
                        b2 = true;
                    else if (inputString.Equals("n"))
                        b2 = false;
                    else
                        invalidInput = true;
                }//end if
                break;
            case 3:
                if (!invalidInput)
                {
                    a3.buildArray();
                    a3.display();
                    Console.WriteLine("Is your number here?");
                    Console.WriteLine("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.ToLower();
                    if (inputString.Equals("y"))
                        b3 = true;
                    else if (inputString.Equals("n"))
                        b3 = false;
                    else
                        invalidInput = true;
                }//end if
                break;
            case 4:
                if (!invalidInput)
                {
                    a4.buildArray();
                    a4.display();
                    Console.WriteLine("Is your number here?");
                    Console.WriteLine("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.ToLower();
                    if (inputString.Equals("y"))
                        b4 = true;
                    else if (inputString.Equals("n"))
                        b4 = false;
                    else
                        invalidInput = true;
                }//end if
                break;
            case 5:
                if (!invalidInput)
                {
                    a5.buildArray();
                    a5.display();
                    Console.WriteLine("Is your number here?");
                    Console.WriteLine("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.ToLower();
                    if (inputString.Equals("y"))
                        b5 = true;
                    else if (inputString.Equals("n"))
                        b5 = false;
                    else
                        invalidInput = true;
                }//end if
                break;
            case 6:
                if (!invalidInput)
                {
                    a6.buildArray();
                    a6.display();
                    Console.WriteLine("Is your number here?");
                    Console.WriteLine("Y/N: ");
                    inputString = u.getUserInput();
                    inputString = inputString.ToLower();
                    if (inputString.Equals("y"))
                        b6 = true;
                    else if (inputString.Equals("n"))
                        b6 = false;
                    else
                        invalidInput = true;
                }//end if
                break;        
        }//end switch
    }//end showNumberSet()

    public void calculate()
    {
        if (!invalidInput)
        {
            if (b1)
                answer += 1;
            if (b2)
                answer += 2;
            if (b3)
                answer += 4;
            if (b4)
                answer += 8;
            if (b5)
                answer += 16;
            if (b6)
                answer += 32;
        }//end if
    }//end calculate()

    public void displayResult()
    {
        if (invalidInput)
            Console.WriteLine("ERROR: Invalid input detected.");
        else if (answer < 1)
            Console.WriteLine("Your number is less than 1 or greater than 63.");
        else
            Console.WriteLine("Your number is " + answer);
        Thread.Sleep(5000);
    }//end displayResult()

    public void runAgain()
    {
        string input;
        Console.WriteLine("Would you like to run this again?");
        Console.WriteLine("Y/N: ");
        input = u.getUserInput().ToLower();
        if (input.Equals("y"))
            run = true;
        else if (input.Equals("n"))
            run = false;
        else
        {
            Console.WriteLine("ERROR: Invalid input detected.");
            Thread.Sleep(2000);
            Console.WriteLine("Goodbye.");
            Thread.Sleep(1750);
            Environment.Exit(0);
        }//end else
    }//end runAgain()

    public Boolean getRunAgain()
    {
        return run;
    }//end getRunAgain()
}//end class Logic