public class Array
{
    private String [] numbers;
    private final int SIZE;
    private int arrayType;

    public Array (int maxSize, int type)
    {
        SIZE = maxSize;
        numbers = new String[SIZE];
        arrayType = type;
    }

    public void buildArray()
    {
        switch (arrayType)
        {
            case 1:
                numbers[0] = "1 3 5 7 9 11 13 15";
                numbers[1] = "17 19 21 23 25 27 29 31";
                numbers[2] = "33 35 37 39 41 43 45 47";
                numbers[3] = "49 51 53 55 57 59 61 63";
                break;
            case 2:
                numbers[0] = "2 3 6 7 10 11 14 15 ";
                numbers[1] = "18 19 22 23 26 27 30 31";
                numbers[2] = "34 35 38 39 42 43 46 47";
                numbers[3] = "50 51 54 55 58 59 62 63";
                break;
            case 3:
                numbers[0] = "4 5 6 7 12 13 14 15";
                numbers[1] = "20 21 22 23 28 29 30 31";
                numbers[2] = "36 37 38 39 44 45 46 47";
                numbers[3] = "52 53 54 55 60 61 62 63";
                break;
            case 4:
                numbers[0] = "8 9 10 11 12 13 14 15";
                numbers[1] = "24 25 26 27 28 29 30 31";
                numbers[2] = "40 41 42 43 44 45 46 47";
                numbers[3] = "56 57 58 59 60 61 62 63";
                break;
            case 5:
                numbers[0] = "16 17 18 19 20 21 22 23";
                numbers[1] = "24 25 26 27 28 29 30 31";
                numbers[2] = "48 49 50 51 52 53 54 55";
                numbers[3] = "56 57 58 59 60 61 62 63";
                break;
            case 6:
                numbers[0] = "32 33 34 35 36 37 38 39";
                numbers[1] = "40 41 42 43 44 45 46 47";
                numbers[2] = "48 49 50 51 52 53 54 55";
                numbers[3] = "56 57 58 59 60 61 62 63";
                break;
            default:
                throw new IllegalStateException("Unexpected value: " + arrayType);
        }
    }

    public void display()
    {
        int i;
        for (i = 0; i < SIZE; i++)
            System.out.println(numbers[i]);
    }
}
